// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/bigquery/storage/v1beta1/storage.proto
// Original file comments:
// Copyright 2020 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fbigquery_2fstorage_2fv1beta1_2fstorage_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fbigquery_2fstorage_2fv1beta1_2fstorage_2eproto__INCLUDED

#include "google/cloud/bigquery/storage/v1beta1/storage.pb.h"

#include <functional>
#include <grpcpp/impl/codegen/async_generic_service.h>
#include <grpcpp/impl/codegen/async_stream.h>
#include <grpcpp/impl/codegen/async_unary_call.h>
#include <grpcpp/impl/codegen/client_callback.h>
#include <grpcpp/impl/codegen/client_context.h>
#include <grpcpp/impl/codegen/completion_queue.h>
#include <grpcpp/impl/codegen/message_allocator.h>
#include <grpcpp/impl/codegen/method_handler.h>
#include <grpcpp/impl/codegen/proto_utils.h>
#include <grpcpp/impl/codegen/rpc_method.h>
#include <grpcpp/impl/codegen/server_callback.h>
#include <grpcpp/impl/codegen/server_callback_handlers.h>
#include <grpcpp/impl/codegen/server_context.h>
#include <grpcpp/impl/codegen/service_type.h>
#include <grpcpp/impl/codegen/status.h>
#include <grpcpp/impl/codegen/stub_options.h>
#include <grpcpp/impl/codegen/sync_stream.h>

namespace google {
namespace cloud {
namespace bigquery {
namespace storage {
namespace v1beta1 {

// BigQuery storage API.
//
// The BigQuery storage API can be used to read data stored in BigQuery.
class BigQueryStorage final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.bigquery.storage.v1beta1.BigQueryStorage";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Creates a new read session. A read session divides the contents of a
    // BigQuery table into one or more streams, which can then be used to read
    // data from the table. The read session also specifies properties of the
    // data to be read, such as a list of columns or a push-down filter describing
    // the rows to be returned.
    //
    // A particular row can be read by at most one stream. When the caller has
    // reached the end of each stream in the session, then all the data in the
    // table has been read.
    //
    // Read sessions automatically expire 24 hours after they are created and do
    // not require manual clean-up by the caller.
    virtual ::grpc::Status CreateReadSession(::grpc::ClientContext* context, const ::google::cloud::bigquery::storage::v1beta1::CreateReadSessionRequest& request, ::google::cloud::bigquery::storage::v1beta1::ReadSession* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::storage::v1beta1::ReadSession>> AsyncCreateReadSession(::grpc::ClientContext* context, const ::google::cloud::bigquery::storage::v1beta1::CreateReadSessionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::storage::v1beta1::ReadSession>>(AsyncCreateReadSessionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::storage::v1beta1::ReadSession>> PrepareAsyncCreateReadSession(::grpc::ClientContext* context, const ::google::cloud::bigquery::storage::v1beta1::CreateReadSessionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::storage::v1beta1::ReadSession>>(PrepareAsyncCreateReadSessionRaw(context, request, cq));
    }
    // Reads rows from the table in the format prescribed by the read session.
    // Each response contains one or more table rows, up to a maximum of 10 MiB
    // per response; read requests which attempt to read individual rows larger
    // than this will fail.
    //
    // Each request also returns a set of stream statistics reflecting the
    // estimated total number of rows in the read stream. This number is computed
    // based on the total table size and the number of active streams in the read
    // session, and may change as other streams continue to read data.
    std::unique_ptr< ::grpc::ClientReaderInterface< ::google::cloud::bigquery::storage::v1beta1::ReadRowsResponse>> ReadRows(::grpc::ClientContext* context, const ::google::cloud::bigquery::storage::v1beta1::ReadRowsRequest& request) {
      return std::unique_ptr< ::grpc::ClientReaderInterface< ::google::cloud::bigquery::storage::v1beta1::ReadRowsResponse>>(ReadRowsRaw(context, request));
    }
    std::unique_ptr< ::grpc::ClientAsyncReaderInterface< ::google::cloud::bigquery::storage::v1beta1::ReadRowsResponse>> AsyncReadRows(::grpc::ClientContext* context, const ::google::cloud::bigquery::storage::v1beta1::ReadRowsRequest& request, ::grpc::CompletionQueue* cq, void* tag) {
      return std::unique_ptr< ::grpc::ClientAsyncReaderInterface< ::google::cloud::bigquery::storage::v1beta1::ReadRowsResponse>>(AsyncReadRowsRaw(context, request, cq, tag));
    }
    std::unique_ptr< ::grpc::ClientAsyncReaderInterface< ::google::cloud::bigquery::storage::v1beta1::ReadRowsResponse>> PrepareAsyncReadRows(::grpc::ClientContext* context, const ::google::cloud::bigquery::storage::v1beta1::ReadRowsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncReaderInterface< ::google::cloud::bigquery::storage::v1beta1::ReadRowsResponse>>(PrepareAsyncReadRowsRaw(context, request, cq));
    }
    // Creates additional streams for a ReadSession. This API can be used to
    // dynamically adjust the parallelism of a batch processing task upwards by
    // adding additional workers.
    virtual ::grpc::Status BatchCreateReadSessionStreams(::grpc::ClientContext* context, const ::google::cloud::bigquery::storage::v1beta1::BatchCreateReadSessionStreamsRequest& request, ::google::cloud::bigquery::storage::v1beta1::BatchCreateReadSessionStreamsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::storage::v1beta1::BatchCreateReadSessionStreamsResponse>> AsyncBatchCreateReadSessionStreams(::grpc::ClientContext* context, const ::google::cloud::bigquery::storage::v1beta1::BatchCreateReadSessionStreamsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::storage::v1beta1::BatchCreateReadSessionStreamsResponse>>(AsyncBatchCreateReadSessionStreamsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::storage::v1beta1::BatchCreateReadSessionStreamsResponse>> PrepareAsyncBatchCreateReadSessionStreams(::grpc::ClientContext* context, const ::google::cloud::bigquery::storage::v1beta1::BatchCreateReadSessionStreamsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::storage::v1beta1::BatchCreateReadSessionStreamsResponse>>(PrepareAsyncBatchCreateReadSessionStreamsRaw(context, request, cq));
    }
    // Triggers the graceful termination of a single stream in a ReadSession. This
    // API can be used to dynamically adjust the parallelism of a batch processing
    // task downwards without losing data.
    //
    // This API does not delete the stream -- it remains visible in the
    // ReadSession, and any data processed by the stream is not released to other
    // streams. However, no additional data will be assigned to the stream once
    // this call completes. Callers must continue reading data on the stream until
    // the end of the stream is reached so that data which has already been
    // assigned to the stream will be processed.
    //
    // This method will return an error if there are no other live streams
    // in the Session, or if SplitReadStream() has been called on the given
    // Stream.
    virtual ::grpc::Status FinalizeStream(::grpc::ClientContext* context, const ::google::cloud::bigquery::storage::v1beta1::FinalizeStreamRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncFinalizeStream(::grpc::ClientContext* context, const ::google::cloud::bigquery::storage::v1beta1::FinalizeStreamRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncFinalizeStreamRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncFinalizeStream(::grpc::ClientContext* context, const ::google::cloud::bigquery::storage::v1beta1::FinalizeStreamRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncFinalizeStreamRaw(context, request, cq));
    }
    // Splits a given read stream into two Streams. These streams are referred to
    // as the primary and the residual of the split. The original stream can still
    // be read from in the same manner as before. Both of the returned streams can
    // also be read from, and the total rows return by both child streams will be
    // the same as the rows read from the original stream.
    //
    // Moreover, the two child streams will be allocated back to back in the
    // original Stream. Concretely, it is guaranteed that for streams Original,
    // Primary, and Residual, that Original[0-j] = Primary[0-j] and
    // Original[j-n] = Residual[0-m] once the streams have been read to
    // completion.
    //
    // This method is guaranteed to be idempotent.
    virtual ::grpc::Status SplitReadStream(::grpc::ClientContext* context, const ::google::cloud::bigquery::storage::v1beta1::SplitReadStreamRequest& request, ::google::cloud::bigquery::storage::v1beta1::SplitReadStreamResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::storage::v1beta1::SplitReadStreamResponse>> AsyncSplitReadStream(::grpc::ClientContext* context, const ::google::cloud::bigquery::storage::v1beta1::SplitReadStreamRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::storage::v1beta1::SplitReadStreamResponse>>(AsyncSplitReadStreamRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::storage::v1beta1::SplitReadStreamResponse>> PrepareAsyncSplitReadStream(::grpc::ClientContext* context, const ::google::cloud::bigquery::storage::v1beta1::SplitReadStreamRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::storage::v1beta1::SplitReadStreamResponse>>(PrepareAsyncSplitReadStreamRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Creates a new read session. A read session divides the contents of a
      // BigQuery table into one or more streams, which can then be used to read
      // data from the table. The read session also specifies properties of the
      // data to be read, such as a list of columns or a push-down filter describing
      // the rows to be returned.
      //
      // A particular row can be read by at most one stream. When the caller has
      // reached the end of each stream in the session, then all the data in the
      // table has been read.
      //
      // Read sessions automatically expire 24 hours after they are created and do
      // not require manual clean-up by the caller.
      virtual void CreateReadSession(::grpc::ClientContext* context, const ::google::cloud::bigquery::storage::v1beta1::CreateReadSessionRequest* request, ::google::cloud::bigquery::storage::v1beta1::ReadSession* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateReadSession(::grpc::ClientContext* context, const ::google::cloud::bigquery::storage::v1beta1::CreateReadSessionRequest* request, ::google::cloud::bigquery::storage::v1beta1::ReadSession* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Reads rows from the table in the format prescribed by the read session.
      // Each response contains one or more table rows, up to a maximum of 10 MiB
      // per response; read requests which attempt to read individual rows larger
      // than this will fail.
      //
      // Each request also returns a set of stream statistics reflecting the
      // estimated total number of rows in the read stream. This number is computed
      // based on the total table size and the number of active streams in the read
      // session, and may change as other streams continue to read data.
      virtual void ReadRows(::grpc::ClientContext* context, const ::google::cloud::bigquery::storage::v1beta1::ReadRowsRequest* request, ::grpc::ClientReadReactor< ::google::cloud::bigquery::storage::v1beta1::ReadRowsResponse>* reactor) = 0;
      // Creates additional streams for a ReadSession. This API can be used to
      // dynamically adjust the parallelism of a batch processing task upwards by
      // adding additional workers.
      virtual void BatchCreateReadSessionStreams(::grpc::ClientContext* context, const ::google::cloud::bigquery::storage::v1beta1::BatchCreateReadSessionStreamsRequest* request, ::google::cloud::bigquery::storage::v1beta1::BatchCreateReadSessionStreamsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void BatchCreateReadSessionStreams(::grpc::ClientContext* context, const ::google::cloud::bigquery::storage::v1beta1::BatchCreateReadSessionStreamsRequest* request, ::google::cloud::bigquery::storage::v1beta1::BatchCreateReadSessionStreamsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Triggers the graceful termination of a single stream in a ReadSession. This
      // API can be used to dynamically adjust the parallelism of a batch processing
      // task downwards without losing data.
      //
      // This API does not delete the stream -- it remains visible in the
      // ReadSession, and any data processed by the stream is not released to other
      // streams. However, no additional data will be assigned to the stream once
      // this call completes. Callers must continue reading data on the stream until
      // the end of the stream is reached so that data which has already been
      // assigned to the stream will be processed.
      //
      // This method will return an error if there are no other live streams
      // in the Session, or if SplitReadStream() has been called on the given
      // Stream.
      virtual void FinalizeStream(::grpc::ClientContext* context, const ::google::cloud::bigquery::storage::v1beta1::FinalizeStreamRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void FinalizeStream(::grpc::ClientContext* context, const ::google::cloud::bigquery::storage::v1beta1::FinalizeStreamRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Splits a given read stream into two Streams. These streams are referred to
      // as the primary and the residual of the split. The original stream can still
      // be read from in the same manner as before. Both of the returned streams can
      // also be read from, and the total rows return by both child streams will be
      // the same as the rows read from the original stream.
      //
      // Moreover, the two child streams will be allocated back to back in the
      // original Stream. Concretely, it is guaranteed that for streams Original,
      // Primary, and Residual, that Original[0-j] = Primary[0-j] and
      // Original[j-n] = Residual[0-m] once the streams have been read to
      // completion.
      //
      // This method is guaranteed to be idempotent.
      virtual void SplitReadStream(::grpc::ClientContext* context, const ::google::cloud::bigquery::storage::v1beta1::SplitReadStreamRequest* request, ::google::cloud::bigquery::storage::v1beta1::SplitReadStreamResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void SplitReadStream(::grpc::ClientContext* context, const ::google::cloud::bigquery::storage::v1beta1::SplitReadStreamRequest* request, ::google::cloud::bigquery::storage::v1beta1::SplitReadStreamResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::storage::v1beta1::ReadSession>* AsyncCreateReadSessionRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::storage::v1beta1::CreateReadSessionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::storage::v1beta1::ReadSession>* PrepareAsyncCreateReadSessionRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::storage::v1beta1::CreateReadSessionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientReaderInterface< ::google::cloud::bigquery::storage::v1beta1::ReadRowsResponse>* ReadRowsRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::storage::v1beta1::ReadRowsRequest& request) = 0;
    virtual ::grpc::ClientAsyncReaderInterface< ::google::cloud::bigquery::storage::v1beta1::ReadRowsResponse>* AsyncReadRowsRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::storage::v1beta1::ReadRowsRequest& request, ::grpc::CompletionQueue* cq, void* tag) = 0;
    virtual ::grpc::ClientAsyncReaderInterface< ::google::cloud::bigquery::storage::v1beta1::ReadRowsResponse>* PrepareAsyncReadRowsRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::storage::v1beta1::ReadRowsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::storage::v1beta1::BatchCreateReadSessionStreamsResponse>* AsyncBatchCreateReadSessionStreamsRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::storage::v1beta1::BatchCreateReadSessionStreamsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::storage::v1beta1::BatchCreateReadSessionStreamsResponse>* PrepareAsyncBatchCreateReadSessionStreamsRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::storage::v1beta1::BatchCreateReadSessionStreamsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncFinalizeStreamRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::storage::v1beta1::FinalizeStreamRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncFinalizeStreamRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::storage::v1beta1::FinalizeStreamRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::storage::v1beta1::SplitReadStreamResponse>* AsyncSplitReadStreamRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::storage::v1beta1::SplitReadStreamRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::storage::v1beta1::SplitReadStreamResponse>* PrepareAsyncSplitReadStreamRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::storage::v1beta1::SplitReadStreamRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status CreateReadSession(::grpc::ClientContext* context, const ::google::cloud::bigquery::storage::v1beta1::CreateReadSessionRequest& request, ::google::cloud::bigquery::storage::v1beta1::ReadSession* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::storage::v1beta1::ReadSession>> AsyncCreateReadSession(::grpc::ClientContext* context, const ::google::cloud::bigquery::storage::v1beta1::CreateReadSessionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::storage::v1beta1::ReadSession>>(AsyncCreateReadSessionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::storage::v1beta1::ReadSession>> PrepareAsyncCreateReadSession(::grpc::ClientContext* context, const ::google::cloud::bigquery::storage::v1beta1::CreateReadSessionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::storage::v1beta1::ReadSession>>(PrepareAsyncCreateReadSessionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientReader< ::google::cloud::bigquery::storage::v1beta1::ReadRowsResponse>> ReadRows(::grpc::ClientContext* context, const ::google::cloud::bigquery::storage::v1beta1::ReadRowsRequest& request) {
      return std::unique_ptr< ::grpc::ClientReader< ::google::cloud::bigquery::storage::v1beta1::ReadRowsResponse>>(ReadRowsRaw(context, request));
    }
    std::unique_ptr< ::grpc::ClientAsyncReader< ::google::cloud::bigquery::storage::v1beta1::ReadRowsResponse>> AsyncReadRows(::grpc::ClientContext* context, const ::google::cloud::bigquery::storage::v1beta1::ReadRowsRequest& request, ::grpc::CompletionQueue* cq, void* tag) {
      return std::unique_ptr< ::grpc::ClientAsyncReader< ::google::cloud::bigquery::storage::v1beta1::ReadRowsResponse>>(AsyncReadRowsRaw(context, request, cq, tag));
    }
    std::unique_ptr< ::grpc::ClientAsyncReader< ::google::cloud::bigquery::storage::v1beta1::ReadRowsResponse>> PrepareAsyncReadRows(::grpc::ClientContext* context, const ::google::cloud::bigquery::storage::v1beta1::ReadRowsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncReader< ::google::cloud::bigquery::storage::v1beta1::ReadRowsResponse>>(PrepareAsyncReadRowsRaw(context, request, cq));
    }
    ::grpc::Status BatchCreateReadSessionStreams(::grpc::ClientContext* context, const ::google::cloud::bigquery::storage::v1beta1::BatchCreateReadSessionStreamsRequest& request, ::google::cloud::bigquery::storage::v1beta1::BatchCreateReadSessionStreamsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::storage::v1beta1::BatchCreateReadSessionStreamsResponse>> AsyncBatchCreateReadSessionStreams(::grpc::ClientContext* context, const ::google::cloud::bigquery::storage::v1beta1::BatchCreateReadSessionStreamsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::storage::v1beta1::BatchCreateReadSessionStreamsResponse>>(AsyncBatchCreateReadSessionStreamsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::storage::v1beta1::BatchCreateReadSessionStreamsResponse>> PrepareAsyncBatchCreateReadSessionStreams(::grpc::ClientContext* context, const ::google::cloud::bigquery::storage::v1beta1::BatchCreateReadSessionStreamsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::storage::v1beta1::BatchCreateReadSessionStreamsResponse>>(PrepareAsyncBatchCreateReadSessionStreamsRaw(context, request, cq));
    }
    ::grpc::Status FinalizeStream(::grpc::ClientContext* context, const ::google::cloud::bigquery::storage::v1beta1::FinalizeStreamRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncFinalizeStream(::grpc::ClientContext* context, const ::google::cloud::bigquery::storage::v1beta1::FinalizeStreamRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncFinalizeStreamRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncFinalizeStream(::grpc::ClientContext* context, const ::google::cloud::bigquery::storage::v1beta1::FinalizeStreamRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncFinalizeStreamRaw(context, request, cq));
    }
    ::grpc::Status SplitReadStream(::grpc::ClientContext* context, const ::google::cloud::bigquery::storage::v1beta1::SplitReadStreamRequest& request, ::google::cloud::bigquery::storage::v1beta1::SplitReadStreamResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::storage::v1beta1::SplitReadStreamResponse>> AsyncSplitReadStream(::grpc::ClientContext* context, const ::google::cloud::bigquery::storage::v1beta1::SplitReadStreamRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::storage::v1beta1::SplitReadStreamResponse>>(AsyncSplitReadStreamRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::storage::v1beta1::SplitReadStreamResponse>> PrepareAsyncSplitReadStream(::grpc::ClientContext* context, const ::google::cloud::bigquery::storage::v1beta1::SplitReadStreamRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::storage::v1beta1::SplitReadStreamResponse>>(PrepareAsyncSplitReadStreamRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void CreateReadSession(::grpc::ClientContext* context, const ::google::cloud::bigquery::storage::v1beta1::CreateReadSessionRequest* request, ::google::cloud::bigquery::storage::v1beta1::ReadSession* response, std::function<void(::grpc::Status)>) override;
      void CreateReadSession(::grpc::ClientContext* context, const ::google::cloud::bigquery::storage::v1beta1::CreateReadSessionRequest* request, ::google::cloud::bigquery::storage::v1beta1::ReadSession* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ReadRows(::grpc::ClientContext* context, const ::google::cloud::bigquery::storage::v1beta1::ReadRowsRequest* request, ::grpc::ClientReadReactor< ::google::cloud::bigquery::storage::v1beta1::ReadRowsResponse>* reactor) override;
      void BatchCreateReadSessionStreams(::grpc::ClientContext* context, const ::google::cloud::bigquery::storage::v1beta1::BatchCreateReadSessionStreamsRequest* request, ::google::cloud::bigquery::storage::v1beta1::BatchCreateReadSessionStreamsResponse* response, std::function<void(::grpc::Status)>) override;
      void BatchCreateReadSessionStreams(::grpc::ClientContext* context, const ::google::cloud::bigquery::storage::v1beta1::BatchCreateReadSessionStreamsRequest* request, ::google::cloud::bigquery::storage::v1beta1::BatchCreateReadSessionStreamsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void FinalizeStream(::grpc::ClientContext* context, const ::google::cloud::bigquery::storage::v1beta1::FinalizeStreamRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void FinalizeStream(::grpc::ClientContext* context, const ::google::cloud::bigquery::storage::v1beta1::FinalizeStreamRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
      void SplitReadStream(::grpc::ClientContext* context, const ::google::cloud::bigquery::storage::v1beta1::SplitReadStreamRequest* request, ::google::cloud::bigquery::storage::v1beta1::SplitReadStreamResponse* response, std::function<void(::grpc::Status)>) override;
      void SplitReadStream(::grpc::ClientContext* context, const ::google::cloud::bigquery::storage::v1beta1::SplitReadStreamRequest* request, ::google::cloud::bigquery::storage::v1beta1::SplitReadStreamResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::storage::v1beta1::ReadSession>* AsyncCreateReadSessionRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::storage::v1beta1::CreateReadSessionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::storage::v1beta1::ReadSession>* PrepareAsyncCreateReadSessionRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::storage::v1beta1::CreateReadSessionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientReader< ::google::cloud::bigquery::storage::v1beta1::ReadRowsResponse>* ReadRowsRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::storage::v1beta1::ReadRowsRequest& request) override;
    ::grpc::ClientAsyncReader< ::google::cloud::bigquery::storage::v1beta1::ReadRowsResponse>* AsyncReadRowsRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::storage::v1beta1::ReadRowsRequest& request, ::grpc::CompletionQueue* cq, void* tag) override;
    ::grpc::ClientAsyncReader< ::google::cloud::bigquery::storage::v1beta1::ReadRowsResponse>* PrepareAsyncReadRowsRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::storage::v1beta1::ReadRowsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::storage::v1beta1::BatchCreateReadSessionStreamsResponse>* AsyncBatchCreateReadSessionStreamsRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::storage::v1beta1::BatchCreateReadSessionStreamsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::storage::v1beta1::BatchCreateReadSessionStreamsResponse>* PrepareAsyncBatchCreateReadSessionStreamsRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::storage::v1beta1::BatchCreateReadSessionStreamsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncFinalizeStreamRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::storage::v1beta1::FinalizeStreamRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncFinalizeStreamRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::storage::v1beta1::FinalizeStreamRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::storage::v1beta1::SplitReadStreamResponse>* AsyncSplitReadStreamRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::storage::v1beta1::SplitReadStreamRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::storage::v1beta1::SplitReadStreamResponse>* PrepareAsyncSplitReadStreamRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::storage::v1beta1::SplitReadStreamRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_CreateReadSession_;
    const ::grpc::internal::RpcMethod rpcmethod_ReadRows_;
    const ::grpc::internal::RpcMethod rpcmethod_BatchCreateReadSessionStreams_;
    const ::grpc::internal::RpcMethod rpcmethod_FinalizeStream_;
    const ::grpc::internal::RpcMethod rpcmethod_SplitReadStream_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Creates a new read session. A read session divides the contents of a
    // BigQuery table into one or more streams, which can then be used to read
    // data from the table. The read session also specifies properties of the
    // data to be read, such as a list of columns or a push-down filter describing
    // the rows to be returned.
    //
    // A particular row can be read by at most one stream. When the caller has
    // reached the end of each stream in the session, then all the data in the
    // table has been read.
    //
    // Read sessions automatically expire 24 hours after they are created and do
    // not require manual clean-up by the caller.
    virtual ::grpc::Status CreateReadSession(::grpc::ServerContext* context, const ::google::cloud::bigquery::storage::v1beta1::CreateReadSessionRequest* request, ::google::cloud::bigquery::storage::v1beta1::ReadSession* response);
    // Reads rows from the table in the format prescribed by the read session.
    // Each response contains one or more table rows, up to a maximum of 10 MiB
    // per response; read requests which attempt to read individual rows larger
    // than this will fail.
    //
    // Each request also returns a set of stream statistics reflecting the
    // estimated total number of rows in the read stream. This number is computed
    // based on the total table size and the number of active streams in the read
    // session, and may change as other streams continue to read data.
    virtual ::grpc::Status ReadRows(::grpc::ServerContext* context, const ::google::cloud::bigquery::storage::v1beta1::ReadRowsRequest* request, ::grpc::ServerWriter< ::google::cloud::bigquery::storage::v1beta1::ReadRowsResponse>* writer);
    // Creates additional streams for a ReadSession. This API can be used to
    // dynamically adjust the parallelism of a batch processing task upwards by
    // adding additional workers.
    virtual ::grpc::Status BatchCreateReadSessionStreams(::grpc::ServerContext* context, const ::google::cloud::bigquery::storage::v1beta1::BatchCreateReadSessionStreamsRequest* request, ::google::cloud::bigquery::storage::v1beta1::BatchCreateReadSessionStreamsResponse* response);
    // Triggers the graceful termination of a single stream in a ReadSession. This
    // API can be used to dynamically adjust the parallelism of a batch processing
    // task downwards without losing data.
    //
    // This API does not delete the stream -- it remains visible in the
    // ReadSession, and any data processed by the stream is not released to other
    // streams. However, no additional data will be assigned to the stream once
    // this call completes. Callers must continue reading data on the stream until
    // the end of the stream is reached so that data which has already been
    // assigned to the stream will be processed.
    //
    // This method will return an error if there are no other live streams
    // in the Session, or if SplitReadStream() has been called on the given
    // Stream.
    virtual ::grpc::Status FinalizeStream(::grpc::ServerContext* context, const ::google::cloud::bigquery::storage::v1beta1::FinalizeStreamRequest* request, ::google::protobuf::Empty* response);
    // Splits a given read stream into two Streams. These streams are referred to
    // as the primary and the residual of the split. The original stream can still
    // be read from in the same manner as before. Both of the returned streams can
    // also be read from, and the total rows return by both child streams will be
    // the same as the rows read from the original stream.
    //
    // Moreover, the two child streams will be allocated back to back in the
    // original Stream. Concretely, it is guaranteed that for streams Original,
    // Primary, and Residual, that Original[0-j] = Primary[0-j] and
    // Original[j-n] = Residual[0-m] once the streams have been read to
    // completion.
    //
    // This method is guaranteed to be idempotent.
    virtual ::grpc::Status SplitReadStream(::grpc::ServerContext* context, const ::google::cloud::bigquery::storage::v1beta1::SplitReadStreamRequest* request, ::google::cloud::bigquery::storage::v1beta1::SplitReadStreamResponse* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateReadSession : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateReadSession() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_CreateReadSession() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateReadSession(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::storage::v1beta1::CreateReadSessionRequest* /*request*/, ::google::cloud::bigquery::storage::v1beta1::ReadSession* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateReadSession(::grpc::ServerContext* context, ::google::cloud::bigquery::storage::v1beta1::CreateReadSessionRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::bigquery::storage::v1beta1::ReadSession>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ReadRows : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ReadRows() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_ReadRows() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ReadRows(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::storage::v1beta1::ReadRowsRequest* /*request*/, ::grpc::ServerWriter< ::google::cloud::bigquery::storage::v1beta1::ReadRowsResponse>* /*writer*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestReadRows(::grpc::ServerContext* context, ::google::cloud::bigquery::storage::v1beta1::ReadRowsRequest* request, ::grpc::ServerAsyncWriter< ::google::cloud::bigquery::storage::v1beta1::ReadRowsResponse>* writer, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncServerStreaming(1, context, request, writer, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_BatchCreateReadSessionStreams : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_BatchCreateReadSessionStreams() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_BatchCreateReadSessionStreams() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchCreateReadSessionStreams(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::storage::v1beta1::BatchCreateReadSessionStreamsRequest* /*request*/, ::google::cloud::bigquery::storage::v1beta1::BatchCreateReadSessionStreamsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestBatchCreateReadSessionStreams(::grpc::ServerContext* context, ::google::cloud::bigquery::storage::v1beta1::BatchCreateReadSessionStreamsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::bigquery::storage::v1beta1::BatchCreateReadSessionStreamsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_FinalizeStream : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_FinalizeStream() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_FinalizeStream() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status FinalizeStream(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::storage::v1beta1::FinalizeStreamRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestFinalizeStream(::grpc::ServerContext* context, ::google::cloud::bigquery::storage::v1beta1::FinalizeStreamRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_SplitReadStream : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_SplitReadStream() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_SplitReadStream() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SplitReadStream(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::storage::v1beta1::SplitReadStreamRequest* /*request*/, ::google::cloud::bigquery::storage::v1beta1::SplitReadStreamResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSplitReadStream(::grpc::ServerContext* context, ::google::cloud::bigquery::storage::v1beta1::SplitReadStreamRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::bigquery::storage::v1beta1::SplitReadStreamResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_CreateReadSession<WithAsyncMethod_ReadRows<WithAsyncMethod_BatchCreateReadSessionStreams<WithAsyncMethod_FinalizeStream<WithAsyncMethod_SplitReadStream<Service > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_CreateReadSession : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateReadSession() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::bigquery::storage::v1beta1::CreateReadSessionRequest, ::google::cloud::bigquery::storage::v1beta1::ReadSession>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::bigquery::storage::v1beta1::CreateReadSessionRequest* request, ::google::cloud::bigquery::storage::v1beta1::ReadSession* response) { return this->CreateReadSession(context, request, response); }));}
    void SetMessageAllocatorFor_CreateReadSession(
        ::grpc::MessageAllocator< ::google::cloud::bigquery::storage::v1beta1::CreateReadSessionRequest, ::google::cloud::bigquery::storage::v1beta1::ReadSession>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::bigquery::storage::v1beta1::CreateReadSessionRequest, ::google::cloud::bigquery::storage::v1beta1::ReadSession>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateReadSession() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateReadSession(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::storage::v1beta1::CreateReadSessionRequest* /*request*/, ::google::cloud::bigquery::storage::v1beta1::ReadSession* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateReadSession(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::bigquery::storage::v1beta1::CreateReadSessionRequest* /*request*/, ::google::cloud::bigquery::storage::v1beta1::ReadSession* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ReadRows : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ReadRows() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackServerStreamingHandler< ::google::cloud::bigquery::storage::v1beta1::ReadRowsRequest, ::google::cloud::bigquery::storage::v1beta1::ReadRowsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::bigquery::storage::v1beta1::ReadRowsRequest* request) { return this->ReadRows(context, request); }));
    }
    ~WithCallbackMethod_ReadRows() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ReadRows(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::storage::v1beta1::ReadRowsRequest* /*request*/, ::grpc::ServerWriter< ::google::cloud::bigquery::storage::v1beta1::ReadRowsResponse>* /*writer*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerWriteReactor< ::google::cloud::bigquery::storage::v1beta1::ReadRowsResponse>* ReadRows(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::bigquery::storage::v1beta1::ReadRowsRequest* /*request*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_BatchCreateReadSessionStreams : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_BatchCreateReadSessionStreams() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::bigquery::storage::v1beta1::BatchCreateReadSessionStreamsRequest, ::google::cloud::bigquery::storage::v1beta1::BatchCreateReadSessionStreamsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::bigquery::storage::v1beta1::BatchCreateReadSessionStreamsRequest* request, ::google::cloud::bigquery::storage::v1beta1::BatchCreateReadSessionStreamsResponse* response) { return this->BatchCreateReadSessionStreams(context, request, response); }));}
    void SetMessageAllocatorFor_BatchCreateReadSessionStreams(
        ::grpc::MessageAllocator< ::google::cloud::bigquery::storage::v1beta1::BatchCreateReadSessionStreamsRequest, ::google::cloud::bigquery::storage::v1beta1::BatchCreateReadSessionStreamsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::bigquery::storage::v1beta1::BatchCreateReadSessionStreamsRequest, ::google::cloud::bigquery::storage::v1beta1::BatchCreateReadSessionStreamsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_BatchCreateReadSessionStreams() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchCreateReadSessionStreams(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::storage::v1beta1::BatchCreateReadSessionStreamsRequest* /*request*/, ::google::cloud::bigquery::storage::v1beta1::BatchCreateReadSessionStreamsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* BatchCreateReadSessionStreams(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::bigquery::storage::v1beta1::BatchCreateReadSessionStreamsRequest* /*request*/, ::google::cloud::bigquery::storage::v1beta1::BatchCreateReadSessionStreamsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_FinalizeStream : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_FinalizeStream() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::bigquery::storage::v1beta1::FinalizeStreamRequest, ::google::protobuf::Empty>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::bigquery::storage::v1beta1::FinalizeStreamRequest* request, ::google::protobuf::Empty* response) { return this->FinalizeStream(context, request, response); }));}
    void SetMessageAllocatorFor_FinalizeStream(
        ::grpc::MessageAllocator< ::google::cloud::bigquery::storage::v1beta1::FinalizeStreamRequest, ::google::protobuf::Empty>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::bigquery::storage::v1beta1::FinalizeStreamRequest, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_FinalizeStream() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status FinalizeStream(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::storage::v1beta1::FinalizeStreamRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* FinalizeStream(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::bigquery::storage::v1beta1::FinalizeStreamRequest* /*request*/, ::google::protobuf::Empty* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_SplitReadStream : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_SplitReadStream() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::bigquery::storage::v1beta1::SplitReadStreamRequest, ::google::cloud::bigquery::storage::v1beta1::SplitReadStreamResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::bigquery::storage::v1beta1::SplitReadStreamRequest* request, ::google::cloud::bigquery::storage::v1beta1::SplitReadStreamResponse* response) { return this->SplitReadStream(context, request, response); }));}
    void SetMessageAllocatorFor_SplitReadStream(
        ::grpc::MessageAllocator< ::google::cloud::bigquery::storage::v1beta1::SplitReadStreamRequest, ::google::cloud::bigquery::storage::v1beta1::SplitReadStreamResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::bigquery::storage::v1beta1::SplitReadStreamRequest, ::google::cloud::bigquery::storage::v1beta1::SplitReadStreamResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_SplitReadStream() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SplitReadStream(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::storage::v1beta1::SplitReadStreamRequest* /*request*/, ::google::cloud::bigquery::storage::v1beta1::SplitReadStreamResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SplitReadStream(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::bigquery::storage::v1beta1::SplitReadStreamRequest* /*request*/, ::google::cloud::bigquery::storage::v1beta1::SplitReadStreamResponse* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_CreateReadSession<WithCallbackMethod_ReadRows<WithCallbackMethod_BatchCreateReadSessionStreams<WithCallbackMethod_FinalizeStream<WithCallbackMethod_SplitReadStream<Service > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_CreateReadSession : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateReadSession() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_CreateReadSession() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateReadSession(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::storage::v1beta1::CreateReadSessionRequest* /*request*/, ::google::cloud::bigquery::storage::v1beta1::ReadSession* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ReadRows : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ReadRows() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_ReadRows() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ReadRows(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::storage::v1beta1::ReadRowsRequest* /*request*/, ::grpc::ServerWriter< ::google::cloud::bigquery::storage::v1beta1::ReadRowsResponse>* /*writer*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_BatchCreateReadSessionStreams : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_BatchCreateReadSessionStreams() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_BatchCreateReadSessionStreams() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchCreateReadSessionStreams(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::storage::v1beta1::BatchCreateReadSessionStreamsRequest* /*request*/, ::google::cloud::bigquery::storage::v1beta1::BatchCreateReadSessionStreamsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_FinalizeStream : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_FinalizeStream() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_FinalizeStream() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status FinalizeStream(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::storage::v1beta1::FinalizeStreamRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_SplitReadStream : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_SplitReadStream() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_SplitReadStream() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SplitReadStream(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::storage::v1beta1::SplitReadStreamRequest* /*request*/, ::google::cloud::bigquery::storage::v1beta1::SplitReadStreamResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateReadSession : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateReadSession() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_CreateReadSession() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateReadSession(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::storage::v1beta1::CreateReadSessionRequest* /*request*/, ::google::cloud::bigquery::storage::v1beta1::ReadSession* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateReadSession(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ReadRows : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ReadRows() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_ReadRows() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ReadRows(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::storage::v1beta1::ReadRowsRequest* /*request*/, ::grpc::ServerWriter< ::google::cloud::bigquery::storage::v1beta1::ReadRowsResponse>* /*writer*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestReadRows(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncWriter< ::grpc::ByteBuffer>* writer, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncServerStreaming(1, context, request, writer, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_BatchCreateReadSessionStreams : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_BatchCreateReadSessionStreams() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_BatchCreateReadSessionStreams() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchCreateReadSessionStreams(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::storage::v1beta1::BatchCreateReadSessionStreamsRequest* /*request*/, ::google::cloud::bigquery::storage::v1beta1::BatchCreateReadSessionStreamsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestBatchCreateReadSessionStreams(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_FinalizeStream : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_FinalizeStream() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_FinalizeStream() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status FinalizeStream(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::storage::v1beta1::FinalizeStreamRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestFinalizeStream(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_SplitReadStream : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_SplitReadStream() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_SplitReadStream() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SplitReadStream(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::storage::v1beta1::SplitReadStreamRequest* /*request*/, ::google::cloud::bigquery::storage::v1beta1::SplitReadStreamResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSplitReadStream(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateReadSession : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateReadSession() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateReadSession(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateReadSession() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateReadSession(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::storage::v1beta1::CreateReadSessionRequest* /*request*/, ::google::cloud::bigquery::storage::v1beta1::ReadSession* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateReadSession(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ReadRows : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ReadRows() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackServerStreamingHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const::grpc::ByteBuffer* request) { return this->ReadRows(context, request); }));
    }
    ~WithRawCallbackMethod_ReadRows() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ReadRows(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::storage::v1beta1::ReadRowsRequest* /*request*/, ::grpc::ServerWriter< ::google::cloud::bigquery::storage::v1beta1::ReadRowsResponse>* /*writer*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerWriteReactor< ::grpc::ByteBuffer>* ReadRows(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_BatchCreateReadSessionStreams : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_BatchCreateReadSessionStreams() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->BatchCreateReadSessionStreams(context, request, response); }));
    }
    ~WithRawCallbackMethod_BatchCreateReadSessionStreams() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchCreateReadSessionStreams(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::storage::v1beta1::BatchCreateReadSessionStreamsRequest* /*request*/, ::google::cloud::bigquery::storage::v1beta1::BatchCreateReadSessionStreamsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* BatchCreateReadSessionStreams(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_FinalizeStream : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_FinalizeStream() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->FinalizeStream(context, request, response); }));
    }
    ~WithRawCallbackMethod_FinalizeStream() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status FinalizeStream(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::storage::v1beta1::FinalizeStreamRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* FinalizeStream(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_SplitReadStream : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_SplitReadStream() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->SplitReadStream(context, request, response); }));
    }
    ~WithRawCallbackMethod_SplitReadStream() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SplitReadStream(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::storage::v1beta1::SplitReadStreamRequest* /*request*/, ::google::cloud::bigquery::storage::v1beta1::SplitReadStreamResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SplitReadStream(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateReadSession : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateReadSession() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::bigquery::storage::v1beta1::CreateReadSessionRequest, ::google::cloud::bigquery::storage::v1beta1::ReadSession>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::bigquery::storage::v1beta1::CreateReadSessionRequest, ::google::cloud::bigquery::storage::v1beta1::ReadSession>* streamer) {
                       return this->StreamedCreateReadSession(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateReadSession() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateReadSession(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::storage::v1beta1::CreateReadSessionRequest* /*request*/, ::google::cloud::bigquery::storage::v1beta1::ReadSession* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateReadSession(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::bigquery::storage::v1beta1::CreateReadSessionRequest,::google::cloud::bigquery::storage::v1beta1::ReadSession>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_BatchCreateReadSessionStreams : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_BatchCreateReadSessionStreams() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::bigquery::storage::v1beta1::BatchCreateReadSessionStreamsRequest, ::google::cloud::bigquery::storage::v1beta1::BatchCreateReadSessionStreamsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::bigquery::storage::v1beta1::BatchCreateReadSessionStreamsRequest, ::google::cloud::bigquery::storage::v1beta1::BatchCreateReadSessionStreamsResponse>* streamer) {
                       return this->StreamedBatchCreateReadSessionStreams(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_BatchCreateReadSessionStreams() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status BatchCreateReadSessionStreams(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::storage::v1beta1::BatchCreateReadSessionStreamsRequest* /*request*/, ::google::cloud::bigquery::storage::v1beta1::BatchCreateReadSessionStreamsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedBatchCreateReadSessionStreams(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::bigquery::storage::v1beta1::BatchCreateReadSessionStreamsRequest,::google::cloud::bigquery::storage::v1beta1::BatchCreateReadSessionStreamsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_FinalizeStream : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_FinalizeStream() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::bigquery::storage::v1beta1::FinalizeStreamRequest, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::bigquery::storage::v1beta1::FinalizeStreamRequest, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedFinalizeStream(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_FinalizeStream() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status FinalizeStream(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::storage::v1beta1::FinalizeStreamRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedFinalizeStream(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::bigquery::storage::v1beta1::FinalizeStreamRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_SplitReadStream : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_SplitReadStream() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::bigquery::storage::v1beta1::SplitReadStreamRequest, ::google::cloud::bigquery::storage::v1beta1::SplitReadStreamResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::bigquery::storage::v1beta1::SplitReadStreamRequest, ::google::cloud::bigquery::storage::v1beta1::SplitReadStreamResponse>* streamer) {
                       return this->StreamedSplitReadStream(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_SplitReadStream() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status SplitReadStream(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::storage::v1beta1::SplitReadStreamRequest* /*request*/, ::google::cloud::bigquery::storage::v1beta1::SplitReadStreamResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedSplitReadStream(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::bigquery::storage::v1beta1::SplitReadStreamRequest,::google::cloud::bigquery::storage::v1beta1::SplitReadStreamResponse>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_CreateReadSession<WithStreamedUnaryMethod_BatchCreateReadSessionStreams<WithStreamedUnaryMethod_FinalizeStream<WithStreamedUnaryMethod_SplitReadStream<Service > > > > StreamedUnaryService;
  template <class BaseClass>
  class WithSplitStreamingMethod_ReadRows : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithSplitStreamingMethod_ReadRows() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::SplitServerStreamingHandler<
          ::google::cloud::bigquery::storage::v1beta1::ReadRowsRequest, ::google::cloud::bigquery::storage::v1beta1::ReadRowsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerSplitStreamer<
                     ::google::cloud::bigquery::storage::v1beta1::ReadRowsRequest, ::google::cloud::bigquery::storage::v1beta1::ReadRowsResponse>* streamer) {
                       return this->StreamedReadRows(context,
                         streamer);
                  }));
    }
    ~WithSplitStreamingMethod_ReadRows() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ReadRows(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::storage::v1beta1::ReadRowsRequest* /*request*/, ::grpc::ServerWriter< ::google::cloud::bigquery::storage::v1beta1::ReadRowsResponse>* /*writer*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with split streamed
    virtual ::grpc::Status StreamedReadRows(::grpc::ServerContext* context, ::grpc::ServerSplitStreamer< ::google::cloud::bigquery::storage::v1beta1::ReadRowsRequest,::google::cloud::bigquery::storage::v1beta1::ReadRowsResponse>* server_split_streamer) = 0;
  };
  typedef WithSplitStreamingMethod_ReadRows<Service > SplitStreamedService;
  typedef WithStreamedUnaryMethod_CreateReadSession<WithSplitStreamingMethod_ReadRows<WithStreamedUnaryMethod_BatchCreateReadSessionStreams<WithStreamedUnaryMethod_FinalizeStream<WithStreamedUnaryMethod_SplitReadStream<Service > > > > > StreamedService;
};

}  // namespace v1beta1
}  // namespace storage
}  // namespace bigquery
}  // namespace cloud
}  // namespace google


#endif  // GRPC_google_2fcloud_2fbigquery_2fstorage_2fv1beta1_2fstorage_2eproto__INCLUDED
