# Copyright 2018 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

include(CMakeFindDependencyMacro)
# googleapis finds both gRPC and Protobuf, no need to load them here.
find_dependency(googleapis)
find_dependency(google_cloud_cpp_common)
find_dependency(google_cloud_cpp_grpc_utils)
find_dependency(absl)

include("${CMAKE_CURRENT_LIST_DIR}/bigtable-targets.cmake")

if (NOT TARGET bigtable::protos)
    add_library(bigtable::protos IMPORTED INTERFACE)
    set_target_properties(bigtable::protos PROPERTIES
        INTERFACE_LINK_LIBRARIES "bigtable_protos")
endif ()

if (NOT TARGET bigtable::client)
    add_library(bigtable::client IMPORTED INTERFACE)
    set_target_properties(bigtable::client PROPERTIES
        INTERFACE_LINK_LIBRARIES "bigtable_client")
endif ()
